// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "FileWatchApp.h"

#include "MainFrm.h"
#include "FileWatch.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




/////////////////////////////////////////////////////////////////////////////
// CTextToolBar

BOOL CTextToolBar::LoadToolBar(UINT nIDResource)
{
	if (!CToolBar::LoadToolBar(nIDResource))
		return FALSE;

	// Set the text for each button
	CToolBarCtrl& bar = GetToolBarCtrl();

	// Remove the string map in case we are loading another toolbar into this control
	delete m_pStringMap;
	m_pStringMap = NULL;

	CSize sizeMax(0,0);
	for (int nIndex=0; nIndex<bar.GetButtonCount(); nIndex++)
	{
		TBBUTTON tb;
		bar.GetButton(nIndex, &tb);

		if ((tb.fsStyle&TBSTYLE_SEP) !=  TBSTYLE_SEP && tb.idCommand)
		{
			CString strButtonText;
			strButtonText.LoadString(tb.idCommand);
			int i = strButtonText.ReverseFind('\n');
			if (i>=0)
				strButtonText = strButtonText.Mid(i+1);
			SetButtonText(nIndex, strButtonText);

			CRect rc;
			bar.GetItemRect(nIndex, rc);
			sizeMax.cx = __max(rc.Width(), sizeMax.cx);
			sizeMax.cy = __max(rc.Height(), sizeMax.cy);
		}
	}

	// Resize the buttons so that the text will fit.
	SetSizes(sizeMax, CSize(16,15));

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_AUTORELOAD, OnFileAutoreload)
	ON_UPDATE_COMMAND_UI(ID_FILE_AUTORELOAD, OnUpdateFileAutoreload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_OVR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bAutoReload = FALSE;
}

CMainFrame::~CMainFrame()
{

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnClose() 
{
	CFileWatch::Stop();

	CMDIFrameWnd::OnClose();
}

void CMainFrame::OnFileAutoreload() 
{
	m_bAutoReload = !m_bAutoReload;
}

void CMainFrame::OnUpdateFileAutoreload(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bAutoReload);
}
